function [u] = update_u(M, z, u, v, gamma) 
% given z, v, update u

a=M;
a(~isnan(a))=1;
a(isnan(a))=0;
l=0;
grad=[];
M(isnan(M))=0;
for i=1:size(a,1)
    %the following is calculated for gradient
	gtemp=(u(i)*z(i)*(a(i,:).*v')-a(i,:).*M(i,:))*z(i)*(a(i,:).*v')';
	grad(i)=gtemp;
    %the following is calculated for lipschitz modulis
	av=a(i,:).*v';
	l=l+(av*av'*z(i)^2)^2;
end
lip = sqrt(l);
if lip == 0
    u = zeros(length(u), 1);
    return;
end
u = u - 1 / (gamma * lip) * grad';
end
