function [z] = update_z(M, z, u, v, gamma, s) 
% given u, v, update z
l=0;
grad=[];
a=M{1};
for i=1:size(a,1)
    %the following is calculated for gradient
	gtemp=0;
	grad(i)=0;
	for j=1:length(M)
	a=M{j};
	M{j}(isnan(M{j}))=0;
	a(~isnan(a))=1;
	a(isnan(a))=0;
	gtemp=(u(i,j)*z(i)*(a(i,:).*v{j}')-a(i,:).*M{j}(i,:))*u(i,j)*(a(i,:).*v{j}')';
	grad(i)=grad(i)+gtemp;
	end
    %the following is calculated for lipschitz modulis
	for j=1:length(M)
	a=M{j};
	av=a(i,:).*v{j}';
	l=l+(av*av'*u(i,j)^2)^2;
	end
end
lip = sqrt(l);
if lip == 0 
    z = zeros(length(z), 1);
    return;
end
z = z - 1 / (lip * gamma) * grad';
z = map(z, s);
end